// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/ConnectionManeuverAssist.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__CONNECTION_MANEUVER_ASSIST__TRAITS_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__CONNECTION_MANEUVER_ASSIST__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_spatem_ts_msgs/msg/detail/connection_maneuver_assist__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'connection_id'
#include "etsi_its_spatem_ts_msgs/msg/detail/lane_connection_id__traits.hpp"
// Member 'queue_length'
// Member 'available_storage_length'
#include "etsi_its_spatem_ts_msgs/msg/detail/zone_length__traits.hpp"
// Member 'wait_on_stop'
#include "etsi_its_spatem_ts_msgs/msg/detail/wait_on_stopline__traits.hpp"
// Member 'ped_bicycle_detect'
#include "etsi_its_spatem_ts_msgs/msg/detail/pedestrian_bicycle_detect__traits.hpp"

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ConnectionManeuverAssist & msg,
  std::ostream & out)
{
  out << "{";
  // member: connection_id
  {
    out << "connection_id: ";
    to_flow_style_yaml(msg.connection_id, out);
    out << ", ";
  }

  // member: queue_length
  {
    out << "queue_length: ";
    to_flow_style_yaml(msg.queue_length, out);
    out << ", ";
  }

  // member: queue_length_is_present
  {
    out << "queue_length_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.queue_length_is_present, out);
    out << ", ";
  }

  // member: available_storage_length
  {
    out << "available_storage_length: ";
    to_flow_style_yaml(msg.available_storage_length, out);
    out << ", ";
  }

  // member: available_storage_length_is_present
  {
    out << "available_storage_length_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.available_storage_length_is_present, out);
    out << ", ";
  }

  // member: wait_on_stop
  {
    out << "wait_on_stop: ";
    to_flow_style_yaml(msg.wait_on_stop, out);
    out << ", ";
  }

  // member: wait_on_stop_is_present
  {
    out << "wait_on_stop_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.wait_on_stop_is_present, out);
    out << ", ";
  }

  // member: ped_bicycle_detect
  {
    out << "ped_bicycle_detect: ";
    to_flow_style_yaml(msg.ped_bicycle_detect, out);
    out << ", ";
  }

  // member: ped_bicycle_detect_is_present
  {
    out << "ped_bicycle_detect_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.ped_bicycle_detect_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ConnectionManeuverAssist & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: connection_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connection_id:\n";
    to_block_style_yaml(msg.connection_id, out, indentation + 2);
  }

  // member: queue_length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "queue_length:\n";
    to_block_style_yaml(msg.queue_length, out, indentation + 2);
  }

  // member: queue_length_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "queue_length_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.queue_length_is_present, out);
    out << "\n";
  }

  // member: available_storage_length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "available_storage_length:\n";
    to_block_style_yaml(msg.available_storage_length, out, indentation + 2);
  }

  // member: available_storage_length_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "available_storage_length_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.available_storage_length_is_present, out);
    out << "\n";
  }

  // member: wait_on_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wait_on_stop:\n";
    to_block_style_yaml(msg.wait_on_stop, out, indentation + 2);
  }

  // member: wait_on_stop_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wait_on_stop_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.wait_on_stop_is_present, out);
    out << "\n";
  }

  // member: ped_bicycle_detect
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ped_bicycle_detect:\n";
    to_block_style_yaml(msg.ped_bicycle_detect, out, indentation + 2);
  }

  // member: ped_bicycle_detect_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ped_bicycle_detect_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.ped_bicycle_detect_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ConnectionManeuverAssist & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_spatem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_spatem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_spatem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist & msg)
{
  return etsi_its_spatem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist>()
{
  return "etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist";
}

template<>
inline const char * name<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist>()
{
  return "etsi_its_spatem_ts_msgs/msg/ConnectionManeuverAssist";
}

template<>
struct has_fixed_size<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist>
  : std::integral_constant<bool, has_fixed_size<etsi_its_spatem_ts_msgs::msg::LaneConnectionID>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::PedestrianBicycleDetect>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::WaitOnStopline>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::ZoneLength>::value> {};

template<>
struct has_bounded_size<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist>
  : std::integral_constant<bool, has_bounded_size<etsi_its_spatem_ts_msgs::msg::LaneConnectionID>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::PedestrianBicycleDetect>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::WaitOnStopline>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::ZoneLength>::value> {};

template<>
struct is_message<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__CONNECTION_MANEUVER_ASSIST__TRAITS_HPP_
