// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/IntersectionStatusObject.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__INTERSECTION_STATUS_OBJECT__STRUCT_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__INTERSECTION_STATUS_OBJECT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject __declspec(deprecated)
#endif

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct IntersectionStatusObject_
{
  using Type = IntersectionStatusObject_<ContainerAllocator>;

  explicit IntersectionStatusObject_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->bits_unused = 0;
    }
  }

  explicit IntersectionStatusObject_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->bits_unused = 0;
    }
  }

  // field types and members
  using _value_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _value_type value;
  using _bits_unused_type =
    uint8_t;
  _bits_unused_type bits_unused;

  // setters for named parameter idiom
  Type & set__value(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->value = _arg;
    return *this;
  }
  Type & set__bits_unused(
    const uint8_t & _arg)
  {
    this->bits_unused = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t SIZE_BITS =
    16u;
  static constexpr uint8_t BIT_INDEX_MANUAL_CONTROL_IS_ENABLED =
    0u;
  static constexpr uint8_t BIT_INDEX_STOP_TIME_IS_ACTIVATED =
    1u;
  static constexpr uint8_t BIT_INDEX_FAILURE_FLASH =
    2u;
  static constexpr uint8_t BIT_INDEX_PREEMPT_IS_ACTIVE =
    3u;
  static constexpr uint8_t BIT_INDEX_SIGNAL_PRIORITY_IS_ACTIVE =
    4u;
  static constexpr uint8_t BIT_INDEX_FIXED_TIME_OPERATION =
    5u;
  static constexpr uint8_t BIT_INDEX_TRAFFIC_DEPENDENT_OPERATION =
    6u;
  static constexpr uint8_t BIT_INDEX_STANDBY_OPERATION =
    7u;
  static constexpr uint8_t BIT_INDEX_FAILURE_MODE =
    8u;
  static constexpr uint8_t BIT_INDEX_OFF =
    9u;
  static constexpr uint8_t BIT_INDEX_RECENT_MA_PMESSAGE_UPDATE =
    10u;
  static constexpr uint8_t BIT_INDEX_RECENT_CHANGE_IN_MA_PASSIGNED_LANES_I_DS_USED =
    11u;
  static constexpr uint8_t BIT_INDEX_NO_VALID_MA_PIS_AVAILABLE_AT_THIS_TIME =
    12u;
  static constexpr uint8_t BIT_INDEX_NO_VALID_SPA_TIS_AVAILABLE_AT_THIS_TIME =
    13u;

  // pointer types
  using RawPtr =
    etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const IntersectionStatusObject_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    if (this->bits_unused != other.bits_unused) {
      return false;
    }
    return true;
  }
  bool operator!=(const IntersectionStatusObject_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct IntersectionStatusObject_

// alias to use template instance with default allocator
using IntersectionStatusObject =
  etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::SIZE_BITS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_MANUAL_CONTROL_IS_ENABLED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_STOP_TIME_IS_ACTIVATED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_FAILURE_FLASH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_PREEMPT_IS_ACTIVE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_SIGNAL_PRIORITY_IS_ACTIVE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_FIXED_TIME_OPERATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_TRAFFIC_DEPENDENT_OPERATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_STANDBY_OPERATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_FAILURE_MODE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_OFF;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_RECENT_MA_PMESSAGE_UPDATE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_RECENT_CHANGE_IN_MA_PASSIGNED_LANES_I_DS_USED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_NO_VALID_MA_PIS_AVAILABLE_AT_THIS_TIME;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t IntersectionStatusObject_<ContainerAllocator>::BIT_INDEX_NO_VALID_SPA_TIS_AVAILABLE_AT_THIS_TIME;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__INTERSECTION_STATUS_OBJECT__STRUCT_HPP_
