// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/MovementEvent.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_EVENT__STRUCT_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_EVENT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'event_state'
#include "etsi_its_spatem_ts_msgs/msg/detail/movement_phase_state__struct.hpp"
// Member 'timing'
#include "etsi_its_spatem_ts_msgs/msg/detail/time_change_details__struct.hpp"
// Member 'speeds'
#include "etsi_its_spatem_ts_msgs/msg/detail/advisory_speed_list__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__MovementEvent __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__MovementEvent __declspec(deprecated)
#endif

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MovementEvent_
{
  using Type = MovementEvent_<ContainerAllocator>;

  explicit MovementEvent_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : event_state(_init),
    timing(_init),
    speeds(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->timing_is_present = false;
      this->speeds_is_present = false;
    }
  }

  explicit MovementEvent_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : event_state(_alloc, _init),
    timing(_alloc, _init),
    speeds(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->timing_is_present = false;
      this->speeds_is_present = false;
    }
  }

  // field types and members
  using _event_state_type =
    etsi_its_spatem_ts_msgs::msg::MovementPhaseState_<ContainerAllocator>;
  _event_state_type event_state;
  using _timing_type =
    etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator>;
  _timing_type timing;
  using _timing_is_present_type =
    bool;
  _timing_is_present_type timing_is_present;
  using _speeds_type =
    etsi_its_spatem_ts_msgs::msg::AdvisorySpeedList_<ContainerAllocator>;
  _speeds_type speeds;
  using _speeds_is_present_type =
    bool;
  _speeds_is_present_type speeds_is_present;

  // setters for named parameter idiom
  Type & set__event_state(
    const etsi_its_spatem_ts_msgs::msg::MovementPhaseState_<ContainerAllocator> & _arg)
  {
    this->event_state = _arg;
    return *this;
  }
  Type & set__timing(
    const etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator> & _arg)
  {
    this->timing = _arg;
    return *this;
  }
  Type & set__timing_is_present(
    const bool & _arg)
  {
    this->timing_is_present = _arg;
    return *this;
  }
  Type & set__speeds(
    const etsi_its_spatem_ts_msgs::msg::AdvisorySpeedList_<ContainerAllocator> & _arg)
  {
    this->speeds = _arg;
    return *this;
  }
  Type & set__speeds_is_present(
    const bool & _arg)
  {
    this->speeds_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_spatem_ts_msgs::msg::MovementEvent_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_spatem_ts_msgs::msg::MovementEvent_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::MovementEvent_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::MovementEvent_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::MovementEvent_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::MovementEvent_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::MovementEvent_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::MovementEvent_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::MovementEvent_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::MovementEvent_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__MovementEvent
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::MovementEvent_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__MovementEvent
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::MovementEvent_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MovementEvent_ & other) const
  {
    if (this->event_state != other.event_state) {
      return false;
    }
    if (this->timing != other.timing) {
      return false;
    }
    if (this->timing_is_present != other.timing_is_present) {
      return false;
    }
    if (this->speeds != other.speeds) {
      return false;
    }
    if (this->speeds_is_present != other.speeds_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const MovementEvent_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MovementEvent_

// alias to use template instance with default allocator
using MovementEvent =
  etsi_its_spatem_ts_msgs::msg::MovementEvent_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_EVENT__STRUCT_HPP_
