// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_spatem_ts_msgs:msg/SpeedConfidenceDSRC.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__SPEED_CONFIDENCE_DSRC__STRUCT_H_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__SPEED_CONFIDENCE_DSRC__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__UNAVAILABLE = 0
};

/// Constant 'PREC100MS'.
enum
{
  etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__PREC100MS = 1
};

/// Constant 'PREC10MS'.
enum
{
  etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__PREC10MS = 2
};

/// Constant 'PREC5MS'.
enum
{
  etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__PREC5MS = 3
};

/// Constant 'PREC1MS'.
enum
{
  etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__PREC1MS = 4
};

/// Constant 'PREC0_1MS'.
enum
{
  etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__PREC0_1MS = 5
};

/// Constant 'PREC0_05MS'.
enum
{
  etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__PREC0_05MS = 6
};

/// Constant 'PREC0_01MS'.
enum
{
  etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__PREC0_01MS = 7
};

/// Struct defined in msg/SpeedConfidenceDSRC in the package etsi_its_spatem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   spatem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// SpeedConfidenceDSRC ::= ENUMERATED {
  ///    unavailable (0), -- Not Equipped or unavailable
  ///    prec100ms   (1), -- 100  meters / sec
  ///    prec10ms    (2), -- 10   meters / sec
  ///    prec5ms     (3), -- 5    meters / sec
  ///    prec1ms     (4), -- 1    meters / sec
  ///    prec0-1ms   (5), -- 0.1  meters / sec
  ///    prec0-05ms  (6), -- 0.05 meters / sec
  ///    prec0-01ms  (7)  -- 0.01 meters / sec
  ///    }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC;

// Struct for a sequence of etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC.
typedef struct etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__Sequence
{
  etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__SPEED_CONFIDENCE_DSRC__STRUCT_H_
